<template>
  <div>
    <v-card width="100%" elevation="20" color="grey">
      <v-form v-if="task" v-model="valid">
        <v-container>
          <v-row>
            <v-card-title style="width:100%">
              <v-text-field
                :rules="[validationRules.required, validationRules.counter30]"
                solo
                v-model="task.title"
                :readonly="!editTitle"
              >
                <template v-slot:append-outer>
                  <v-slide-x-reverse-transition mode="out-in">
                    <v-icon
                      :key="`icon-${editTitle}`"
                      :color="editTitle ? 'success' : 'info'"
                      @click="editTitle = !editTitle"
                      v-text="
                        editTitle
                          ? 'mdi-check-outline'
                          : 'mdi-circle-edit-outline'
                      "
                    ></v-icon>
                  </v-slide-x-reverse-transition>
                </template>
              </v-text-field>
            </v-card-title>
          </v-row>
          <v-row>
            <v-col cols="4" sm="4">
              <v-select
                solo
                v-model="task.domain_id"
                :rules="[validationRules.required]"
                class="rtl"
                :items="domains"
                item-text="name"
                item-value="id"
              ></v-select>
            </v-col>
            <v-col cols="4" sm="4">
              <v-select
                solo
                :rules="[validationRules.required]"
                v-model="task.type_id"
                class="rtl"
                :items="taskTypes"
                item-text="name"
                item-value="id"
              ></v-select>
            </v-col>
            <v-col class="text-center" cols="3">
              <v-chip class="mt-1">{{ task.status }}</v-chip>
            </v-col>
          </v-row>
          <v-row class="rtl">
            <v-col cols="4" sm="4">
              <v-textarea
                solo
                :rules="[validationRules.required, validationRules.counter300]"
                v-model="task.description"
                class="elad"
              ></v-textarea>
            </v-col>
            <v-col cols="4" sm="4">
              <v-autocomplete
                v-model="task.crew"
                :items="staff"
                :loading="staffIsLoading"
                hide-no-data
                dense
                chips
                small-chips
                multiple
                solo
              ></v-autocomplete>
            </v-col>
            <v-col class="text-center datetime-picker" cols="3" sm="3">
              <h4>תאריך התחלה</h4>
              <v-datetime-picker
                date-format="dd/MM/yyyy"
                :date-picker-props="{ locale: 'he-IL' }"
                :text-field-props="{ prependIcon: 'event' }"
                v-model="task.start"
              ></v-datetime-picker>
              <h4>תאריך סיום</h4>
              <v-datetime-picker
                date-format="dd/MM/yyyy"
                :date-picker-props="{ locale: 'he-IL' }"
                :text-field-props="{
                  prependIcon: 'event',
                  lazyValue: task.end,
                }"
                v-model="task.end"
              ></v-datetime-picker>
            </v-col>
          </v-row>
        </v-container>
        <div style="position:absolute; bottom:40%; left:20px;">
          <v-btn
            :disabled="task.id < 0"
            color="error"
            fab
            @click="$emit('on-task-delete', task.id)"
          >
            <v-icon>mdi-delete</v-icon>
          </v-btn>
          <br />
          <v-btn
            :disabled="!valid"
            color="success"
            fab
            class="mt-2"
            @click="$emit('on-task-save', task)"
          >
            <v-icon>save</v-icon>
          </v-btn>
        </div>
      </v-form>
    </v-card>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { api_base_url } from "../config";
export default {
  props: {
    initialTask: {
      type: Object,
    },
  },
  computed: {
    ...mapGetters("metadata", ["domains", "taskTypes"]),
    computedStartFormatted() {
      return this.formatDate(this.task.start);
    },
  },
  data() {
    return {
      task: null,
      staffIsLoading: false,
      staff: [],
      confirmDelete: false,
      editTitle: false,
      valid: false,
      validationRules: {
        required: (value) => !!value || "שדה חובה",
        counter30: (value) => value.length <= 30 || "עד 30 תווים",
        counter300: (value) => value.length <= 300 || "עד 300 תווים",
      },
    };
  },
  methods: {
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.slice(0, 10).split("-");
      return `${day}/${month}/${year}`;
    },
  },
  // watch: {
  //   initialTask: {
  //     immediate: true,
  //     handler(newInitialTask) {
  //     this.staffIsLoading = true;
  //     if (newInitialTask.start !== null) {
  //       newInitialTask.start = new Date(newInitialTask.start);
  //     }
  //     if (newInitialTask.end !== null) {
  //       newInitialTask.end = new Date(newInitialTask.end);
  //     }
  //     this.task = newInitialTask;
  //     fetch(api_base_url + "metadata/domain-staff/" + this.task.domain_id)
  //       .then(res => res.json())
  //       .then(res => {
  //         this.staff = res;
  //       })
  //       .catch(err => {
  //         window.alert(err);
  //       })
  //       .finally(() => (this.staffIsLoading = false));
  //   }
  // }
  // },
  watch: {
    // whenever question changes, this function will run
    initialTask: function(newInitialTask) {
      this.task = newInitialTask;
      if (this.task.start !== null) {
        this.task.start = new Date(this.task.start);
      }
      if (this.task.end !== null) {
        this.task.end = new Date(this.task.end);
      }
    },
  },
  mounted: function() {
    this.staffIsLoading = true;
    this.task = this.initialTask;
    if (this.task.start !== null) {
      this.task.start = new Date(this.task.start);
    }
    if (this.task.end !== null) {
      this.task.end = new Date(this.task.end);
    }
    if (this.initialTask.id < 0) {
      this.editTitle = true;
    }
    fetch(api_base_url + "metadata/domain-staff/" + this.task.domain_id)
      .then((res) => res.json())
      .then((res) => {
        this.staff = res;
      })
      .catch((err) => {
        window.alert(err);
      })
      .finally(() => (this.staffIsLoading = false));
  },
};
</script>

<style>
.datetime-picker .v-text-field--is-booted {
  direction: ltr !important;
  width: 170px;
  margin-right: auto;
  margin-left: auto;
}

.datetime-picker
  .v-input
  .v-input__prepend-outer
  .v-input__icon--prepend
  .v-icon {
  color: #1976d2;
}
</style>
